Bug 44188 - Empty response for certain requests (mod_proxy as forward proxy)
Summary: Empty response for certain requests (mod_proxy as forward proxy)
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_deflate (show other bugs)
Version: 2.2.6
Hardware: Other Linux
: P1 critical with 1 vote (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2008-01-08 18:20 UTC by Peter Belau
Modified: 2018-11-07 21:09 UTC (History)
1 user (show)



Attachments
httpd conf of the testcase (13.80 KB, text/plain)
2008-05-27 00:06 UTC, rahul
Details
access log of testcase (1.91 KB, text/plain)
2008-05-27 00:07 UTC, rahul
Details
corresponding error log at debug level (26.39 KB, text/plain)
2008-05-27 00:07 UTC, rahul
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Peter Belau 2008-01-08 18:20:53 UTC
I'm seeing sporadically empty and/or incomplete HTTP responses when requesting
certain pages. There is a  Zlib: Validation bytes not present message in the
error_log for the failing request. 

The URL http://httpd.apache.org/docs/1.3/programs/apxs.html

can be used to provoke this strange behavior. Filters are setup as follows:

AddOutputFilterByType INFLATE text/html text/plain text/xml
AddOutputFilterByType DEFLATE text/html text/plain text/xml

This bug is similar to earlier resolved issue:
http://issues.apache.org/bugzilla/show_bug.cgi?id=43512
Comment 1 rahul 2008-05-26 03:46:27 UTC
reproducable in trunk, (tested on solaris 11 sparc machine)
The configuration was

ProxyRequests On
ProxyVia On

<Proxy *>
Allow from all
</Proxy>
LoadModule deflate_module modules/mod_deflate.so

AddOutputFilterByType INFLATE text/html text/plain text/xml
AddOutputFilterByType DEFLATE text/html text/plain text/xml

See the sporadic truncated lengths in access log (given below)
the length of the page is 14004

127.0.0.1 - - [26/May/2008:15:54:28 +0530] "GET http://httpd.apache.org/docs/1.3/programs/apxs.html HTTP/1.0" 200 14004
.....
127.0.0.1 - - [26/May/2008:15:54:47 +0530] "GET http://httpd.apache.org/docs/1.3/programs/apxs.html HTTP/1.0" 200 3881
127.0.0.1 - - [26/May/2008:15:55:09 +0530] "GET http://httpd.apache.org/docs/1.3/programs/apxs.html HTTP/1.0" 200 14004
.....
127.0.0.1 - - [26/May/2008:15:55:26 +0530] "GET http://httpd.apache.org/docs/1.3/programs/apxs.html HTTP/1.0" 200 10781
.....
127.0.0.1 - - [26/May/2008:15:57:54 +0530] "GET http://httpd.apache.org/docs/1.3/programs/apxs.html HTTP/1.0" 200 14004
127.0.0.1 - - [26/May/2008:15:58:00 +0530] "GET http://httpd.apache.org/docs/1.3/programs/apxs.html HTTP/1.0" 200 10781
127.0.0.1 - - [26/May/2008:15:58:08 +0530] "GET http://httpd.apache.org/docs/1.3/programs/apxs.html HTTP/1.0" 200 14004
127.0.0.1 - - [26/May/2008:15:58:14 +0530] "GET http://httpd.apache.org/docs/1.3/programs/apxs.html HTTP/1.0" 200 14004
Comment 2 Ruediger Pluem 2008-05-26 06:34:38 UTC
Please provide the according error_log output to these truncations at loglevel debug.
Comment 3 rahul 2008-05-27 00:06:29 UTC
Created attachment 22006 [details]
httpd conf of the testcase

httpd conf of the testcase
Comment 4 rahul 2008-05-27 00:07:18 UTC
Created attachment 22007 [details]
access log of testcase

access log of testcase
Comment 5 rahul 2008-05-27 00:07:55 UTC
Created attachment 22008 [details]
corresponding error log at debug level

corresponding error log at debug level
Comment 6 Peter Belau 2008-05-27 00:24:23 UTC
(In reply to comment #5)
> Created an attachment (id=22008) [details]
> corresponding error log at debug level
> 
> corresponding error log at debug level
> 



I believe that I have a patch for this in my own branch of Apache. It's a one-liner in mod_deflate AIRC. If anyone else needs it, I'll paste it in.
Comment 7 Ruediger Pluem 2008-05-27 01:59:48 UTC
(In reply to comment #3)
> Created an attachment (id=22006) [details]
> httpd conf of the testcase
> 
> httpd conf of the testcase
> 

Does this configuration really makes sense?
Please try what happens if you remove the INFLATE filter.
Comment 8 Ruediger Pluem 2008-05-27 02:00:47 UTC
(In reply to comment #6)
> (In reply to comment #5)
> > Created an attachment (id=22008) [details] [details]
> > corresponding error log at debug level
> > 
> > corresponding error log at debug level
> > 
> 
> 
> 
> I believe that I have a patch for this in my own branch of Apache. It's a
> one-liner in mod_deflate AIRC. If anyone else needs it, I'll paste it in.
> 

Please let us know your patch. So we can test it and check if it is related to this problem.
Comment 9 Ruediger Pluem 2008-05-27 02:12:30 UTC
Please do a network sniff to the proxied backend to be sure that all data arrives from the proxied backend.
Comment 10 rahul 2008-05-27 04:12:38 UTC
Sorry for the spurious confirmation. After checking the upstream data, the upstream data is also getting truncated. so what I experience is not what is mentioned in this bug.
Comment 11 Rainer Jung 2018-02-25 21:14:57 UTC
Undo spam change
Comment 12 William A. Rowe Jr. 2018-11-07 21:09:36 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.